# setacls.pl
#
# Introp 08 radiator server hook
# This hook is used to derive diffent reply acls for differnet clients
# based on the Callback-Number in the result and the NAS-IP-Address
# mikem@open.com.au
sub 
{ 
    my $p = ${$_[0]}; my $rp = $p->{rp};
    my $result = ${$_[2]};
    if ($p->code() eq 'Access-Request' && $result == $main::ACCEPT) 
    { 
	my $nasip = $p->get_attr('NAS-IP-Address');
	my $cbn =  $rp->get_attr('Callback-Number');
	if ($nasip eq '45.200.1.49' || $nasip eq '45.200.1.50' || $nasip eq '45.200.1.40')
	{ 
	    # Procurve
	    if ($cbn eq '1')
	    {
#		$rp->add_attr('HP-NAS-Filter-Rule', "permit in udp from any to 45.200.1.2 53\0permit in 1 from any to any\0permit in ip from any to 45.200.1.19\0permit in ip from any to 45.200.1.20\0permit in ip from any to 45.200.1.21");
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in udp from any to 45.200.1.2 53');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in 1 from any to 0.0.0.0/0');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in ip from any to 45.200.1.19');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in ip from any to 45.200.1.20');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in ip from any to 45.200.1.21');
	    }
	    elsif ($cbn eq '2')
	    {
#		$rp->add_attr('HP-NAS-Filter-Rule', "permit in udp from any to 45.200.1.2 53\0permit in 1 from any to any\0permit in ip from any to 45.200.1.19");
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in udp from any to 45.200.1.2 53');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in 1 from any to 0.0.0.0/0');
		$rp->add_attr('HP-NAS-Filter-Rule', 'permit in ip from any to 45.200.1.19');
	    }
	    $rp->add_attr('HP-NAS-Filter-Rule', 'permit in udp from any to 0.0.0.0/0 67');
	    $rp->add_attr('HP-NAS-Filter-Rule', 'permit in udp from any to 0.0.0.0/0 68');
	    $rp->add_attr('Tunnel-Private-Group-ID', '20');
	    $rp->add_attr('Tunnel-Medium-Type', 'Ether_802');
	    $rp->add_attr('Tunnel-Type', 'VLAN');
	}
	elsif ($nasip eq '45.200.1.47' || $nasip eq '45.200.1.48')
	{
	    # Enterasys
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Filter-Id', 'Enterasys:version=1:policy=Employee');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Filter-Id', 'Enterasys:version=1:policy=Remediation');
	    }
	}
	elsif ($nasip eq '45.200.1.56')
	{ 
	    # Trapeze
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Filter-Id', 'Employee');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Filter-Id', 'Remediation');
	    }
	    elsif ($cbn eq '5')
	    {
		$rp->add_attr('Filter-Id', 'Admin');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:1000');
		$rp->add_attr('Tunnel-Medium-Type', '1:Ether_802');
		$rp->add_attr('Tunnel-Type', '1:VLAN');
	    }
	}
	elsif ($nasip eq '45.200.1.61' || $nasip eq '45.200.1.62')
	{ 
	    # Xirrus
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Filter-Id', 'Employee');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:20');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Filter-Id', 'Remediation');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:20');
	    }
	    elsif ($cbn eq '5')
	    {
		$rp->add_attr('Filter-Id', 'Admin');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:1000');
	    }
	    $rp->add_attr('Tunnel-Medium-Type', '1:Ether_802');
	    $rp->add_attr('Tunnel-Type', '1:VLAN');
	}
	elsif ($nasip eq '45.200.1.111')
	{ 
	    # Cisco wireless
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Airespace-ACL-Name', 'Employee');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:20');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Airespace-ACL-Name', 'Remediation');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:20');
	    }
	    elsif ($cbn eq '3')
	    {
		$rp->add_attr('Airespace-ACL-Name', 'Guest');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:30');
	    }
	    elsif ($cbn eq '4')
	    {
		$rp->add_attr('Airespace-ACL-Name', 'Device');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:40');
	    }
	    elsif ($cbn eq '5')
	    {
		$rp->add_attr('Airespace-ACL-Name', 'Admin');
		$rp->add_attr('Tunnel-Private-Group-ID', '1:1'); # not 1000
	    }
	    $rp->add_attr('Tunnel-Medium-Type', '1:Ether_802');
	    $rp->add_attr('Tunnel-Type', '1:VLAN');
	}
	elsif ($nasip eq '45.200.1.43' || $nasip eq '45.200.1.44')
	{
	    # Cisco switches
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Filter-Id', '120.in');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Filter-Id', '121.in');
	    }
	}
	elsif ($nasip eq '45.200.1.89')
	{
	    # Aruba
	}
	elsif ($nasip eq '45.200.1.63')
	{
	    # Force10
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '20');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '40');
	    }
	    elsif ($cbn eq '3')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '30');
	    }
	    elsif ($cbn eq '4')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '40');
	    }
	    $rp->add_attr('Tunnel-Medium-Type', 'Ether_802');
	    $rp->add_attr('Tunnel-Type', 'VLAN');
	}
	else
	{
	    #Everything else
	    if ($cbn eq '1')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '1:20');
	    }
	    elsif ($cbn eq '2')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '1:30');
	    }
	    elsif ($cbn eq '5')
	    {
		$rp->add_attr('Tunnel-Private-Group-ID', '1:1000');
	    }
	    $rp->add_attr('Tunnel-Medium-Type', '1:Ether_802');
	    $rp->add_attr('Tunnel-Type', '1:VLAN');
	}
    }
}
